from z3 import *
set_param(proof=True)
try:
	CONRT_EtherStore= DeclareSort('CONRT_EtherStore')
	map= DeclareSort('map')
	EtherStore_balances= Function('EtherStore_balances',CONRT_EtherStore,map)
	EtherStore_votes= Function('EtherStore_votes',CONRT_EtherStore,map)
	address= DeclareSort('address')
	msg_sender= Const('msg_sender',address)
	d1FaddressTuint256mapping= Function('d1FaddressTuint256mapping',map,address,IntSort())
	bal= Int('bal')
	void= DeclareSort('void')
	_1solidity= Const('_1solidity',void)
	TUPLE= DeclareSort('TUPLE')
	TUPLE_0= Const('TUPLE_0',TUPLE)
	LOW_LEVEL_CALL_call= Function('LOW_LEVEL_CALL_call',address,IntSort(),TUPLE)
	sent= Const('sent',BoolSort())
	UNPACK2DTUPLETbool= Function('UNPACK2DTUPLETbool',TUPLE,IntSort(),BoolSort())
	_2solidity= Const('_2solidity',void)
	_1reentrancy_verifier= Int('_1reentrancy_verifier')
	_2reentrancy_verifier= Int('_2reentrancy_verifier')
	IsEtherStore= Function('IsEtherStore',CONRT_EtherStore,BoolSort())
	EtherStore_balances1= Function('EtherStore_balances1',CONRT_EtherStore,map)
	EtherStore_votes1= Function('EtherStore_votes1',CONRT_EtherStore,map)
	msg_sender1= Const('msg_sender1',address)
	d1FaddressTuint256mapping1= Function('d1FaddressTuint256mapping1',map,address,IntSort())
	bal1= Int('bal1')
	_1solidity1= Const('_1solidity1',void)
	TUPLE_01= Const('TUPLE_01',TUPLE)
	LOW_LEVEL_CALL_call1= Function('LOW_LEVEL_CALL_call1',address,IntSort(),TUPLE)
	sent1= Const('sent1',BoolSort())
	UNPACK2DTUPLETbool1= Function('UNPACK2DTUPLETbool1',TUPLE,IntSort(),BoolSort())
	_2solidity1= Const('_2solidity1',void)
	_1reentrancy_verifier1= Int('_1reentrancy_verifier1')
	_2reentrancy_verifier1= Int('_2reentrancy_verifier1')
	_y1= Const('_y1',CONRT_EtherStore)
	_y2= Const('_y2',CONRT_EtherStore)
	_y3= Const('_y3',address)
	_y4= Int('_y4')
	_y5= Const('_y5',TUPLE)
	_y6= Int('_y6')
	_y7= Const('_y7',map)
	_y8= Const('_y8',address)
	_y9= Const('_y9',CONRT_EtherStore)
	_y10= Const('_y10',CONRT_EtherStore)
	_y11= Const('_y11',CONRT_EtherStore)
	_y12= Const('_y12',CONRT_EtherStore)
	_y13= Const('_y13',CONRT_EtherStore)
	_y14= Const('_y14',CONRT_EtherStore)
	_y15= Const('_y15',CONRT_EtherStore)
	_y16= Const('_y16',CONRT_EtherStore)
	_y17= Const('_y17',CONRT_EtherStore)
	_s=Solver()
	_s.set("timeout",50000)
	_s.add(ForAll([_y1],EtherStore_balances1(_y1)==EtherStore_balances(_y1)))
	_s.add(ForAll([_y2],EtherStore_votes1(_y2)==EtherStore_votes(_y2)))
	_s.add(_1solidity1==_1solidity)
	_s.add(ForAll([_y3,_y4],LOW_LEVEL_CALL_call1(_y3,_y4)==LOW_LEVEL_CALL_call(_y3,_y4)))
	_s.add(ForAll([_y5,_y6],UNPACK2DTUPLETbool1(_y5,_y6)==UNPACK2DTUPLETbool(_y5,_y6)))
	_s.add(ForAll([_y7,_y8,_y9,msg_sender],d1FaddressTuint256mapping1(_y7,_y8)==If(((d1FaddressTuint256mapping(EtherStore_balances(_y9),msg_sender))>(0)),If(((If(And(((EtherStore_balances(_y9))==(EtherStore_balances(_y9))),((msg_sender)==(msg_sender))),0,If(And(((EtherStore_balances(_y9))==(EtherStore_votes(_y9))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y9),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y9),msg_sender))))>(0)),If(And(((_y7)==(EtherStore_balances(_y9))),((_y8)==(msg_sender))),0,If(And(((_y7)==(EtherStore_votes(_y9))),((_y8)==(msg_sender))),((If(And(((EtherStore_votes(_y9))==(EtherStore_balances(_y9))),((msg_sender)==(msg_sender))),0,If(And(((EtherStore_votes(_y9))==(EtherStore_votes(_y9))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y9),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_votes(_y9),msg_sender))))-(1)),If(And(((_y7)==(EtherStore_balances(_y9))),((_y8)==(msg_sender))),0,If(And(((_y7)==(EtherStore_votes(_y9))),((_y8)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y9),msg_sender))-(1)),d1FaddressTuint256mapping(_y7,_y8))))),If(And(((_y7)==(EtherStore_balances(_y9))),((_y8)==(msg_sender))),0,If(And(((_y7)==(EtherStore_votes(_y9))),((_y8)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y9),msg_sender))-(1)),d1FaddressTuint256mapping(_y7,_y8)))),d1FaddressTuint256mapping(_y7,_y8))))
	_s.add(ForAll([_y10,msg_sender],bal1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y10),msg_sender))>(0)),If(And(((EtherStore_balances(_y10))==(EtherStore_balances(_y10))),((msg_sender)==(msg_sender))),0,If(And(((EtherStore_balances(_y10))==(EtherStore_votes(_y10))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y10),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y10),msg_sender))),d1FaddressTuint256mapping(EtherStore_balances(_y10),msg_sender))))
	_s.add(ForAll([_y11,msg_sender],TUPLE_01==If(((d1FaddressTuint256mapping(EtherStore_balances(_y11),msg_sender))>(0)),LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y11))==(EtherStore_balances(_y11))),((msg_sender)==(msg_sender))),0,If(And(((EtherStore_balances(_y11))==(EtherStore_votes(_y11))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y11),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y11),msg_sender)))),TUPLE_0)))
	_s.add(ForAll([_y12,msg_sender],sent1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y12),msg_sender))>(0)),UNPACK2DTUPLETbool(LOW_LEVEL_CALL_call(msg_sender,If(And(((EtherStore_balances(_y12))==(EtherStore_balances(_y12))),((msg_sender)==(msg_sender))),0,If(And(((EtherStore_balances(_y12))==(EtherStore_votes(_y12))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y12),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y12),msg_sender)))),0),sent)))
	_s.add(ForAll([_y13,msg_sender],_1reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y13),msg_sender))>(0)),1,0)))
	_s.add(ForAll([_y14,msg_sender],_2reentrancy_verifier1==If(((d1FaddressTuint256mapping(EtherStore_balances(_y14),msg_sender))>(0)),If(((If(And(((EtherStore_balances(_y14))==(EtherStore_balances(_y14))),((msg_sender)==(msg_sender))),0,If(And(((EtherStore_balances(_y14))==(EtherStore_votes(_y14))),((msg_sender)==(msg_sender))),((d1FaddressTuint256mapping(EtherStore_votes(_y14),msg_sender))-(1)),d1FaddressTuint256mapping(EtherStore_balances(_y14),msg_sender))))>(0)),1,0),0)))
	_s.add(ForAll([_y15,msg_sender],((d1FaddressTuint256mapping(EtherStore_balances(_y15),msg_sender))>(0))))
	_s.add(ForAll([_y16],Not(((EtherStore_balances(_y16))==(EtherStore_votes(_y16))))))
	_s.add(ForAll([_y17],Not(((EtherStore_votes(_y17))==(EtherStore_balances(_y17))))))
	_s.add(Not(And((_1reentrancy_verifier1==1),(_2reentrancy_verifier1==0))))
except Exception as e:
	print("Error1(Z3Query)"+str(e))
	sys.exit(1)
try:
	result=_s.check()
	if sat==result:
		print("Counter Example")
		print (_s.model())
	elif unsat==result:
		print ("Successfully Proved")
	else:
		print("Failed To Prove")
except Exception as e:
	print("Error2(Z3Query)"+str(e))
	sys.exit(1)